Imports UJ.ExceptionManagement
Imports UJ.ExceptionManagement.Classes      


Public Class AutoProcessClass
  Implements   IAutoProcess

  Protected _internalValue As String

  Public Sub New(ByVal aValue As String)
    _internalValue = aValue
  End Sub

  'IAutoProcess implementation ---------------------------------------------
  'InspectSelf is called by EMS to let object inspect and report its properties,
  Public Sub InspectSelf(ByVal objectInfo as ObjectInfo) Implements IAutoProcess.InspectSelf 
    MessageBox.Show("Inside AutoProcessClass: EMS called IAutoProcess.InspectSelf")
    ' Let's add property value; it can be object as well
    objectInfo.AddProperty("_internalValue", _internalValue)
    objectInfo.Comments.Add("InspectSelf method added value of _internalValue field.")
  End Sub

  'ComleteProcessing is a chance to finalize/close/release dispose all unmanaged resources
  Public Sub FinalizeSelf (ByVal objectInfo as ObjectInfo) Implements IAutoProcess.FinalizeSelf 
    MessageBox.Show("Inside AutoProcessClass: EMS called IAutoProcess.FinalizeSelf", "Demo")
    objectInfo.Comments.Add("Object was finalized in FinalizeSelf method.")
    ' Here we do some custom finalizing
  End Sub

End Class

Public Class CustomProcessingClass
  Public Sub New(propValue as String )
    _stringProperty = propValue
  End Sub

  public property StringProperty as String 
    Get
      Return _stringProperty
    End Get    
    Set
      _stringProperty = value
    End Set    
  End Property  
  private _stringProperty as String 

End Class

